/******************************************************************************
*
* Filename:     serial.c
* Revision:     1.0
*
******************************************************************************/

#include <hidef.h> /* for EnableInterrupts macro */
#include <string.h> /* for EnableInterrupts macro */
#include "derivative.h" /* include peripheral declarations */

static char n_str[3];
                            
void TERMIO_PutChar(char s_char) {
  byte dummy;	   // dummy var for reading SCIS1
  
  SCI1C2 = 0x08;    // enable Tx
  dummy = SCI1S1;   // 1st half of TDRE clear procedure
  SCI1D = s_char;   // 2nd half of TDRE clear procedure
  while(!SCI1S1_TDRE){
  };
  while(!SCI1S1_TC){
  };
  //SCI1C2_TE = 0;
} //end SendChar

char RecChar() {
  byte rec_char;

  if (SCI1S1_RDRF)  // 1st half of RDRF clear procedure
    rec_char = SCI1D;  // 2nd half of RDRF clear procedure
  SCI1C2_RE = 1;    // enable Rx
  while(!SCI1S1_RDRF){
  };
  rec_char = SCI1D; // get recieved character
  TERMIO_PutChar(rec_char); // echo received character
  return SCI1D;
} //end RecChar  

void SendMsg(char msg[]) {
  byte ix=0;	   // String pointer
  byte dummy;	   // dummy var for reading SCIS1
  byte nxt_char;
  
  SCI1C2 = 0x08;    // enable Tx
  dummy = SCI1S1;   // 1st half of TDRE clear procedure
  nxt_char = msg[ix++];
  while(nxt_char != 0x00) {
    SCI1D = nxt_char; // 2nd half of TDRE clear procedure
    nxt_char = msg[ix++];
    while(!SCI1S1_TDRE){
    };
  } //end while((SCI1D
  while(!SCI1S1_TC){
  };
  //SCI1C2_TE = 0;
} //end SendMsg

char * num2asc(byte n) {
  n_str[0] = (n>>0x04)+0x30;  // convert MSN 'n' to ascii
  if(n_str[0]>0x39)           // if MSN is $a or larger...
    n_str[0]+=0x07;           // ...add $7 to correct
  n_str[1] = (n&0x0f)+0x30;   // convert LSN 'n' to ascii
  if(n_str[1]>0x39)           // if LSN is $a or larger...
    n_str[1]+=0x07;           // ...add $7 to correct
  n_str[2] = 0x00;            // add null
  return n_str;
} //end num2asc

byte asc2num(char n_asc) {
byte n;

  n = n_asc - 0x30;      //convert from ascii to int
  if(n > 0x09)           // if num is $a or larger...
    n -= 0x07;           // ...sub $7 to correct
  if(n > 0x0f)           // if lower case was used...
    n -= 0x20;           // ...sub $20 to correct
  if(n > 0x0f)           // if non-numeric character...
    n = 0x00;            // ...default to '0'
  return n;
} //end asc2num